> ## Documentation Index
> Fetch the complete documentation index at: https://enact-465fb1fc.mintlify.site/llms.txt
> Use this file to discover all available pages before exploring further.

# Schema Reference

## JSON-RPC

### `JSONRPCErrorResponse`

interface JSONRPCErrorResponse \{\
  [jsonrpc](#jsonrpcerrorresponse-jsonrpc): "2.0";\
  [id](#jsonrpcerrorresponse-id)?: [RequestId](#requestid);\
  [error](#jsonrpcerrorresponse-error): [Error](#error);\
}A response to a request that indicates an error occurred. jsonrpc: "2.0"[Permalink](#jsonrpcerrorresponse-jsonrpc)id?: RequestId[Permalink](#jsonrpcerrorresponse-id)error: Error[Permalink](#jsonrpcerrorresponse-error)

### `JSONRPCMessage`

JSONRPCMessage: [JSONRPCRequest](#jsonrpcrequest) | [JSONRPCNotification](#jsonrpcnotification) | [JSONRPCResponse](#jsonrpcresponse)Refers to any valid JSON-RPC object that can be decoded off the wire, or encoded to be sent.&#x20;

### `JSONRPCNotification`

interface JSONRPCNotification \{\
  [method](#jsonrpcnotification-method): string;\
  [params](#jsonrpcnotification-params)?: \{ \[key: string]: any };\
  [jsonrpc](#jsonrpcnotification-jsonrpc): "2.0";\
}A notification which does not expect a response. method: string[Permalink](#jsonrpcnotification-method)Inherited from Notification.methodparams?: \{ \[key: string]: any }[Permalink](#jsonrpcnotification-params)Inherited from Notification.paramsjsonrpc: "2.0"[Permalink](#jsonrpcnotification-jsonrpc)

### `JSONRPCRequest`

interface JSONRPCRequest \{\
  [method](#jsonrpcrequest-method): string;\
  [params](#jsonrpcrequest-params)?: \{ \[key: string]: any };\
  [jsonrpc](#jsonrpcrequest-jsonrpc): "2.0";\
  [id](#jsonrpcrequest-id): [RequestId](#requestid);\
}A request that expects a response. method: string[Permalink](#jsonrpcrequest-method)Inherited from Request.methodparams?: \{ \[key: string]: any }[Permalink](#jsonrpcrequest-params)Inherited from Request.paramsjsonrpc: "2.0"[Permalink](#jsonrpcrequest-jsonrpc)id: RequestId[Permalink](#jsonrpcrequest-id)

### `JSONRPCResponse`

JSONRPCResponse: [JSONRPCResultResponse](#jsonrpcresultresponse) | [JSONRPCErrorResponse](#jsonrpcerrorresponse)A response to a request, containing either the result or error.&#x20;

### `JSONRPCResultResponse`

interface JSONRPCResultResponse \{\
  [jsonrpc](#jsonrpcresultresponse-jsonrpc): "2.0";\
  [id](#jsonrpcresultresponse-id): [RequestId](#requestid);\
  [result](#jsonrpcresultresponse-result): [Result](#result);\
}A successful (non-error) response to a request. jsonrpc: "2.0"[Permalink](#jsonrpcresultresponse-jsonrpc)id: RequestId[Permalink](#jsonrpcresultresponse-id)result: Result[Permalink](#jsonrpcresultresponse-result)

## Common Types

### `Annotations`

interface Annotations \{\
  [audience](#annotations-audience)?: [Role](#role)\[];\
  [priority](#annotations-priority)?: number;\
  [lastModified](#annotations-lastmodified)?: string;\
}Optional annotations for the client. The client can use annotations to inform how objects are used or displayed audience?: Role\[][Permalink](#annotations-audience)Describes who the intended audience of this object or data is. It can include multiple entries to indicate content useful for multiple audiences (e.g., `["user", "assistant"]`). priority?: number[Permalink](#annotations-priority)Describes how important this data is for operating the server. A value of 1 means "most important," and indicates that the data is
effectively required, while 0 means "least important," and indicates that
the data is entirely optional. lastModified?: string[Permalink](#annotations-lastmodified)The moment the resource was last modified, as an ISO 8601 formatted string. Should be an ISO 8601 formatted string (e.g., "2025-01-12T15:00:58Z"). Examples: last activity timestamp in an open file, timestamp when the resource
was attached, etc.&#x20;

### `Cursor`

Cursor: stringAn opaque token used to represent a cursor for pagination.&#x20;

### `EmptyResult`

EmptyResult: [Result](#result)A result that indicates success but carries no data.&#x20;

### `Icon`

interface Icon \{\
  [src](#icon-src): string;\
  [mimeType](#icon-mimetype)?: string;\
  [sizes](#icon-sizes)?: string\[];\
  [theme](#icon-theme)?: "light" | "dark";\
}An optionally-sized icon that can be displayed in a user interface. src: string[Permalink](#icon-src)A standard URI pointing to an icon resource. May be an HTTP/HTTPS URL or a `data:` URI with Base64-encoded image data. Consumers SHOULD take steps to ensure URLs serving icons are from the
same domain as the client/server or a trusted domain. Consumers SHOULD take appropriate precautions when consuming SVGs as they can contain
executable JavaScript. mimeType?: string[Permalink](#icon-mimetype)Optional MIME type override if the source MIME type is missing or generic.
For example: `"image/png"`, `"image/jpeg"`, or `"image/svg+xml"`. sizes?: string\[][Permalink](#icon-sizes)Optional array of strings that specify sizes at which the icon can be used.
Each string should be in WxH format (e.g., `"48x48"`, `"96x96"`) or `"any"` for scalable formats like SVG. If not provided, the client should assume that the icon can be used at any size. theme?: "light" | "dark"[Permalink](#icon-theme)Optional specifier for the theme this icon is designed for. `"light"` indicates
the icon is designed to be used with a light background, and `"dark"` indicates
the icon is designed to be used with a dark background. If not provided, the client should assume the icon can be used with any theme.&#x20;

### `LoggingLevel`

LoggingLevel:\
  | "debug"\
  | "info"\
  | "notice"\
  | "warning"\
  | "error"\
  | "critical"\
  | "alert"\
  | "emergency"The severity of a log message. These map to syslog message severities, as specified in RFC-5424: [[https://datatracker.ietf.org/doc/html/rfc5424#section-6.2.1](https://datatracker.ietf.org/doc/html/rfc5424#section-6.2.1)](https://datatracker.ietf.org/doc/html/rfc5424#section-6.2.1)&#x20;

### `MetaObject`

MetaObject: Record\<string, unknown>Represents the contents of a `_meta` field, which clients and servers use to attach additional metadata to their interactions. Certain key names are reserved by MCP for protocol-level metadata; implementations MUST NOT make assumptions about values at these keys. Additionally, specific schema definitions may reserve particular names for purpose-specific metadata, as declared in those definitions. Valid keys have two segments: **Prefix:** <ul> <li>Optional — if specified, MUST be a series of *labels* separated by dots (`.`), followed by a slash (`/`).</li> <li>Labels MUST start with a letter and end with a letter or digit. Interior characters may be letters, digits, or hyphens (`-`).</li> <li>Any prefix consisting of zero or more labels, followed by `modelcontextprotocol` or `mcp`, followed by any label, is **reserved** for MCP use. For example: `modelcontextprotocol.io/`, `mcp.dev/`, `api.modelcontextprotocol.org/`, and `tools.mcp.com/` are all reserved.</li> </ul> **Name:** <ul> <li>Unless empty, MUST start and end with an alphanumeric character (`[a-z0-9A-Z]`).</li> <li>Interior characters may be alphanumeric, hyphens (`-`), underscores (`_`), or dots (`.`).</li> </ul> See[Permalink](#see)[General fields: `_meta`](https://enact-465fb1fc.mintlify.site/specification/draft/basic/index#meta) for more details.&#x20;

### `NotificationParams`

interface NotificationParams \{\
  [\_meta](#notificationparams-_meta)?: [MetaObject](#metaobject);\
}Common params for any notification. \_meta?: MetaObject[Permalink](#notificationparams-_meta)

### `PaginatedRequestParams`

interface PaginatedRequestParams \{\
  [\_meta](#paginatedrequestparams-_meta)?: [RequestMetaObject](#requestmetaobject);\
  [cursor](#paginatedrequestparams-cursor)?: string;\
}Common params for paginated requests. <details><summary>Example: List request with cursor[Permalink](#paginatedrequestparams-example-list-request-with-cursor)</summary><pre id="paginatedrequestparams-example-list-request-with-cursor">`{  "cursor": "eyJwYWdlIjogMn0="} `Copy</pre> </details>\_meta?: RequestMetaObject[Permalink](#paginatedrequestparams-_meta)Inherited from [RequestParams](#requestparams).[\_meta](#requestparams-_meta)cursor?: string[Permalink](#paginatedrequestparams-cursor)An opaque token representing the current pagination position.
If provided, the server should return results starting after this cursor.&#x20;

### `ProgressToken`

ProgressToken: string | numberA progress token, used to associate progress notifications with the original request.&#x20;

### `RequestId`

RequestId: string | numberA uniquely identifying ID for a request in JSON-RPC.&#x20;

### `RequestMetaObject`

interface RequestMetaObject \{\
  [progressToken](#requestmetaobject-progresstoken)?: [ProgressToken](#progresstoken);\
  \[key: string]: unknown;\
}Extends [MetaObject](#metaobject) with additional request-specific fields. All key naming rules from `MetaObject` apply. See[Permalink](#see)<ul> <li>[MetaObject](#metaobject) for key naming rules and reserved prefixes.</li> <li>[General fields: `_meta`](https://enact-465fb1fc.mintlify.site/specification/draft/basic/index#meta) for more details.</li> </ul> progressToken?: ProgressToken[Permalink](#requestmetaobject-progresstoken)If specified, the caller is requesting out-of-band progress notifications for this request (as represented by [notifications/progress](#progressnotification)). The value of this parameter is an opaque token that will be attached to any subsequent notifications. The receiver is not obligated to provide these notifications.&#x20;

### `RequestParams`

interface RequestParams \{\
  [\_meta](#requestparams-_meta)?: [RequestMetaObject](#requestmetaobject);\
}Common params for any request. \_meta?: RequestMetaObject[Permalink](#requestparams-_meta)

### `Result`

interface Result \{\
  [\_meta](#result-_meta)?: [MetaObject](#metaobject);\
  \[key: string]: unknown;\
}Common result fields. \_meta?: MetaObject[Permalink](#result-_meta)

### `Role`

Role: "user" | "assistant"The sender or recipient of messages and data in a conversation.&#x20;

## Errors

### `Error`

interface Error \{\
  [code](#error-code): number;\
  [message](#error-message): string;\
  [data](#error-data)?: unknown;\
}code: number[Permalink](#error-code)The error type that occurred. message: string[Permalink](#error-message)A short description of the error. The message SHOULD be limited to a concise single sentence. data?: unknown[Permalink](#error-data)Additional information about the error. The value of this member is defined by the sender (e.g. detailed error information, nested errors etc.).&#x20;

### `InternalError`

interface InternalError \{\
  [message](#internalerror-message): string;\
  [data](#internalerror-data)?: unknown;\
  [code](#internalerror-code): -32603;\
}A JSON-RPC error indicating that an internal error occurred on the receiver. This error is returned when the receiver encounters an unexpected condition that prevents it from fulfilling the request. See[Permalink](#see)[JSON-RPC 2.0 Error Object](https://www.jsonrpc.org/specification#error_object) <details><summary>Example: Unexpected error[Permalink](#internalerror-example-unexpected-error)</summary><pre id="internalerror-example-unexpected-error">`{  "code": -32603,  "message": "Internal error"} `Copy</pre> </details>message: string[Permalink](#internalerror-message)A short description of the error. The message SHOULD be limited to a concise single sentence. Inherited from [Error](#error).[message](#error-message)data?: unknown[Permalink](#internalerror-data)Additional information about the error. The value of this member is defined by the sender (e.g. detailed error information, nested errors etc.). Inherited from [Error](#error).[data](#error-data)code: -32603[Permalink](#internalerror-code)The error type that occurred. Overrides [Error](#error).[code](#error-code)

### `InvalidParamsError`

interface InvalidParamsError \{\
  [message](#invalidparamserror-message): string;\
  [data](#invalidparamserror-data)?: unknown;\
  [code](#invalidparamserror-code): -32602;\
}A JSON-RPC error indicating that the method parameters are invalid or malformed. In MCP, this error is returned in various contexts when request parameters fail validation: <ul> <li>**Tools**: Unknown tool name or invalid tool arguments</li> <li>**Prompts**: Unknown prompt name or missing required arguments</li> <li>**Pagination**: Invalid or expired cursor values</li> <li>**Logging**: Invalid log level</li> <li>**Tasks**: Invalid or nonexistent task ID, invalid cursor, or attempting to cancel a task already in a terminal status</li> <li>**Elicitation**: Server requests an elicitation mode not declared in client capabilities</li> <li>**Sampling**: Missing tool result or tool results mixed with other content</li> </ul> See[Permalink](#see)[JSON-RPC 2.0 Error Object](https://www.jsonrpc.org/specification#error_object) <details><summary>Example: Unknown tool[Permalink](#invalidparamserror-example-unknown-tool)</summary><pre id="invalidparamserror-example-unknown-tool">`{  "code": -32602,  "message": "Unknown tool: invalid_tool_name"} `Copy</pre> </details><details><summary>Example: Invalid tool arguments[Permalink](#invalidparamserror-example-invalid-tool-arguments)</summary><pre id="invalidparamserror-example-invalid-tool-arguments">`{  "code": -32602,  "message": "Invalid arguments for tool calculate: Missing required property 'expression'"} `Copy</pre> </details><details><summary>Example: Unknown prompt[Permalink](#invalidparamserror-example-unknown-prompt)</summary><pre id="invalidparamserror-example-unknown-prompt">`{  "code": -32602,  "message": "Unknown prompt: invalid_prompt_name"} `Copy</pre> </details><details><summary>Example: Invalid cursor[Permalink](#invalidparamserror-example-invalid-cursor)</summary><pre id="invalidparamserror-example-invalid-cursor">`{  "code": -32602,  "message": "Invalid cursor"} `Copy</pre> </details>message: string[Permalink](#invalidparamserror-message)A short description of the error. The message SHOULD be limited to a concise single sentence. Inherited from [Error](#error).[message](#error-message)data?: unknown[Permalink](#invalidparamserror-data)Additional information about the error. The value of this member is defined by the sender (e.g. detailed error information, nested errors etc.). Inherited from [Error](#error).[data](#error-data)code: -32602[Permalink](#invalidparamserror-code)The error type that occurred. Overrides [Error](#error).[code](#error-code)

### `InvalidRequestError`

interface InvalidRequestError \{\
  [message](#invalidrequesterror-message): string;\
  [data](#invalidrequesterror-data)?: unknown;\
  [code](#invalidrequesterror-code): -32600;\
}A JSON-RPC error indicating that the request is not a valid request object. This error is returned when the message structure does not conform to the JSON-RPC 2.0 specification requirements for a request (e.g., missing required fields like `jsonrpc` or `method`, or using invalid types for these fields). See[Permalink](#see)[JSON-RPC 2.0 Error Object](https://www.jsonrpc.org/specification#error_object) message: string[Permalink](#invalidrequesterror-message)A short description of the error. The message SHOULD be limited to a concise single sentence. Inherited from [Error](#error).[message](#error-message)data?: unknown[Permalink](#invalidrequesterror-data)Additional information about the error. The value of this member is defined by the sender (e.g. detailed error information, nested errors etc.). Inherited from [Error](#error).[data](#error-data)code: -32600[Permalink](#invalidrequesterror-code)The error type that occurred. Overrides [Error](#error).[code](#error-code)

### `MethodNotFoundError`

interface MethodNotFoundError \{\
  [message](#methodnotfounderror-message): string;\
  [data](#methodnotfounderror-data)?: unknown;\
  [code](#methodnotfounderror-code): -32601;\
}A JSON-RPC error indicating that the requested method does not exist or is not available. In MCP, this error is returned when a request is made for a method that requires a capability that has not been declared. This can occur in either direction: <ul> <li>A server returning this error when the client requests a capability it doesn't support (e.g., requesting completions when the `completions` capability was not advertised)</li> <li>A client returning this error when the server requests a capability it doesn't support (e.g., requesting roots when the client did not declare the `roots` capability)</li> </ul> See[Permalink](#see)[JSON-RPC 2.0 Error Object](https://www.jsonrpc.org/specification#error_object) <details><summary>Example: Roots not supported[Permalink](#methodnotfounderror-example-roots-not-supported)</summary><pre id="methodnotfounderror-example-roots-not-supported">`{  "code": -32601,  "message": "Roots not supported",  "data": {    "reason": "Client does not have roots capability"  }} `Copy</pre> </details>message: string[Permalink](#methodnotfounderror-message)A short description of the error. The message SHOULD be limited to a concise single sentence. Inherited from [Error](#error).[message](#error-message)data?: unknown[Permalink](#methodnotfounderror-data)Additional information about the error. The value of this member is defined by the sender (e.g. detailed error information, nested errors etc.). Inherited from [Error](#error).[data](#error-data)code: -32601[Permalink](#methodnotfounderror-code)The error type that occurred. Overrides [Error](#error).[code](#error-code)

### `ParseError`

interface ParseError \{\
  [message](#parseerror-message): string;\
  [data](#parseerror-data)?: unknown;\
  [code](#parseerror-code): -32700;\
}A JSON-RPC error indicating that invalid JSON was received by the server. This error is returned when the server cannot parse the JSON text of a message. See[Permalink](#see)[JSON-RPC 2.0 Error Object](https://www.jsonrpc.org/specification#error_object) <details><summary>Example: Invalid JSON[Permalink](#parseerror-example-invalid-json)</summary><pre id="parseerror-example-invalid-json">`{  "code": -32700,  "message": "Parse error: Invalid JSON"} `Copy</pre> </details>message: string[Permalink](#parseerror-message)A short description of the error. The message SHOULD be limited to a concise single sentence. Inherited from [Error](#error).[message](#error-message)data?: unknown[Permalink](#parseerror-data)Additional information about the error. The value of this member is defined by the sender (e.g. detailed error information, nested errors etc.). Inherited from [Error](#error).[data](#error-data)code: -32700[Permalink](#parseerror-code)The error type that occurred. Overrides [Error](#error).[code](#error-code)

## Content

### `AudioContent`

interface AudioContent \{\
  [type](#audiocontent-type): "audio";\
  [data](#audiocontent-data): string;\
  [mimeType](#audiocontent-mimetype): string;\
  [annotations](#audiocontent-annotations)?: [Annotations](#annotations);\
  [\_meta](#audiocontent-_meta)?: [MetaObject](#metaobject);\
}Audio provided to or from an LLM. <details><summary>Example: \`audio/wav\` content[Permalink](#audiocontent-example-audiowav-content)</summary><pre id="audiocontent-example-audiowav-content">`{  "type": "audio",  "data": "UklGRiQAAABXQVZFZm10IBAAAAABAAEARKwAAIhYAQACABAAZGF0YQAAAAA=",  "mimeType": "audio/wav"} `Copy</pre> </details>type: "audio"[Permalink](#audiocontent-type)data: string[Permalink](#audiocontent-data)The base64-encoded audio data. mimeType: string[Permalink](#audiocontent-mimetype)The MIME type of the audio. Different providers may support different audio types. annotations?: Annotations[Permalink](#audiocontent-annotations)Optional annotations for the client. \_meta?: MetaObject[Permalink](#audiocontent-_meta)

### `BlobResourceContents`

interface BlobResourceContents \{\
  [uri](#blobresourcecontents-uri): string;\
  [mimeType](#blobresourcecontents-mimetype)?: string;\
  [\_meta](#blobresourcecontents-_meta)?: [MetaObject](#metaobject);\
  [blob](#blobresourcecontents-blob): string;\
}<details><summary>Example: Image file contents[Permalink](#blobresourcecontents-example-image-file-contents)</summary><pre id="blobresourcecontents-example-image-file-contents">`{  "uri": "file:///example.png",  "mimeType": "image/png",  "blob": "iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVR42mNk+M9QDwADhgGAWjR9awAAAABJRU5ErkJggg=="} `Copy</pre> </details>uri: string[Permalink](#blobresourcecontents-uri)The URI of this resource. Inherited from ResourceContents.urimimeType?: string[Permalink](#blobresourcecontents-mimetype)The MIME type of this resource, if known. Inherited from ResourceContents.mimeType\_meta?: MetaObject[Permalink](#blobresourcecontents-_meta)Inherited from ResourceContents.\_metablob: string[Permalink](#blobresourcecontents-blob)A base64-encoded string representing the binary data of the item.&#x20;

### `ContentBlock`

ContentBlock:\
  | [TextContent](#textcontent)\
  | [ImageContent](#imagecontent)\
  | [AudioContent](#audiocontent)\
  | [ResourceLink](#resourcelink)\
  | [EmbeddedResource](#embeddedresource)

### `EmbeddedResource`

interface EmbeddedResource \{\
  [type](#embeddedresource-type): "resource";\
  [resource](#embeddedresource-resource): [TextResourceContents](#textresourcecontents) | [BlobResourceContents](#blobresourcecontents);\
  [annotations](#embeddedresource-annotations)?: [Annotations](#annotations);\
  [\_meta](#embeddedresource-_meta)?: [MetaObject](#metaobject);\
}The contents of a resource, embedded into a prompt or tool call result. It is up to the client how best to render embedded resources for the benefit
of the LLM and/or the user. <details><summary>Example: Embedded file resource with annotations[Permalink](#embeddedresource-example-embedded-file-resource-with-annotations)</summary><pre id="embeddedresource-example-embedded-file-resource-with-annotations">`{  "type": "resource",  "resource": {    "uri": "file:///project/src/main.rs",    "mimeType": "text/x-rust",    "text": "fn main() {\n    println!(\"Hello world!\");\n}"  },  "annotations": {    "audience": ["user", "assistant"],    "priority": 0.7,    "lastModified": "2025-05-03T14:30:00Z"  }} `Copy</pre> </details>type: "resource"[Permalink](#embeddedresource-type)resource: TextResourceContents | BlobResourceContents[Permalink](#embeddedresource-resource)annotations?: Annotations[Permalink](#embeddedresource-annotations)Optional annotations for the client. \_meta?: MetaObject[Permalink](#embeddedresource-_meta)

### `ImageContent`

interface ImageContent \{\
  [type](#imagecontent-type): "image";\
  [data](#imagecontent-data): string;\
  [mimeType](#imagecontent-mimetype): string;\
  [annotations](#imagecontent-annotations)?: [Annotations](#annotations);\
  [\_meta](#imagecontent-_meta)?: [MetaObject](#metaobject);\
}An image provided to or from an LLM. <details><summary>Example: \`image/png\` content with annotations[Permalink](#imagecontent-example-imagepng-content-with-annotations)</summary><pre id="imagecontent-example-imagepng-content-with-annotations">`{  "type": "image",  "data": "iVBORw0KGgoAAAANSUhEUgAAAAEAAAABCAYAAAAfFcSJAAAADUlEQVR42mNk+M9QDwADhgGAWjR9awAAAABJRU5ErkJggg==",  "mimeType": "image/png",  "annotations": {    "audience": ["user"],    "priority": 0.9  }} `Copy</pre> </details>type: "image"[Permalink](#imagecontent-type)data: string[Permalink](#imagecontent-data)The base64-encoded image data. mimeType: string[Permalink](#imagecontent-mimetype)The MIME type of the image. Different providers may support different image types. annotations?: Annotations[Permalink](#imagecontent-annotations)Optional annotations for the client. \_meta?: MetaObject[Permalink](#imagecontent-_meta)

### `ResourceLink`

interface ResourceLink \{\
  [icons](#resourcelink-icons)?: [Icon](#icon)\[];\
  [name](#resourcelink-name): string;\
  [title](#resourcelink-title)?: string;\
  [uri](#resourcelink-uri): string;\
  [description](#resourcelink-description)?: string;\
  [mimeType](#resourcelink-mimetype)?: string;\
  [annotations](#resourcelink-annotations)?: [Annotations](#annotations);\
  [size](#resourcelink-size)?: number;\
  [\_meta](#resourcelink-_meta)?: [MetaObject](#metaobject);\
  [type](#resourcelink-type): "resource\_link";\
}A resource that the server is capable of reading, included in a prompt or tool call result. Note: resource links returned by tools are not guaranteed to appear in the results of [resources/list](#listresourcesrequest) requests. <details><summary>Example: File resource link[Permalink](#resourcelink-example-file-resource-link)</summary><pre id="resourcelink-example-file-resource-link">`{  "type": "resource_link",  "uri": "file:///project/src/main.rs",  "name": "main.rs",  "description": "Primary application entry point",  "mimeType": "text/x-rust"} `Copy</pre> </details>icons?: Icon\[][Permalink](#resourcelink-icons)Optional set of sized icons that the client can display in a user interface. Clients that support rendering icons MUST support at least the following MIME types: <ul> <li>`image/png` - PNG images (safe, universal compatibility)</li> <li>`image/jpeg` (and `image/jpg`) - JPEG images (safe, universal compatibility)</li> </ul> Clients that support rendering icons SHOULD also support: <ul> <li>`image/svg+xml` - SVG images (scalable but requires security precautions)</li> <li>`image/webp` - WebP images (modern, efficient format)</li> </ul> Inherited from [Resource](#resource).[icons](#resource-icons)name: string[Permalink](#resourcelink-name)Intended for programmatic or logical use, but used as a display name in past specs or fallback (if title isn't present). Inherited from [Resource](#resource).[name](#resource-name)title?: string[Permalink](#resourcelink-title)Intended for UI and end-user contexts — optimized to be human-readable and easily understood,
even by those unfamiliar with domain-specific terminology. If not provided, the name should be used for display (except for [Tool](#tool),
where `annotations.title` should be given precedence over using `name`,
if present). Inherited from [Resource](#resource).[title](#resource-title)uri: string[Permalink](#resourcelink-uri)The URI of this resource. Inherited from [Resource](#resource).[uri](#resource-uri)description?: string[Permalink](#resourcelink-description)A description of what this resource represents. This can be used by clients to improve the LLM's understanding of available resources. It can be thought of like a "hint" to the model. Inherited from [Resource](#resource).[description](#resource-description)mimeType?: string[Permalink](#resourcelink-mimetype)The MIME type of this resource, if known. Inherited from [Resource](#resource).[mimeType](#resource-mimetype)annotations?: Annotations[Permalink](#resourcelink-annotations)Optional annotations for the client. Inherited from [Resource](#resource).[annotations](#resource-annotations)size?: number[Permalink](#resourcelink-size)The size of the raw resource content, in bytes (i.e., before base64 encoding or any tokenization), if known. This can be used by Hosts to display file sizes and estimate context window usage. Inherited from [Resource](#resource).[size](#resource-size)\_meta?: MetaObject[Permalink](#resourcelink-_meta)Inherited from [Resource](#resource).[\_meta](#resource-_meta)type: "resource\_link"[Permalink](#resourcelink-type)

### `TextContent`

interface TextContent \{\
  [type](#textcontent-type): "text";\
  [text](#textcontent-text): string;\
  [annotations](#textcontent-annotations)?: [Annotations](#annotations);\
  [\_meta](#textcontent-_meta)?: [MetaObject](#metaobject);\
}Text provided to or from an LLM. <details><summary>Example: Text content[Permalink](#textcontent-example-text-content)</summary><pre id="textcontent-example-text-content">`{  "type": "text",  "text": "Tool result text"} `Copy</pre> </details>type: "text"[Permalink](#textcontent-type)text: string[Permalink](#textcontent-text)The text content of the message. annotations?: Annotations[Permalink](#textcontent-annotations)Optional annotations for the client. \_meta?: MetaObject[Permalink](#textcontent-_meta)

### `TextResourceContents`

interface TextResourceContents \{\
  [uri](#textresourcecontents-uri): string;\
  [mimeType](#textresourcecontents-mimetype)?: string;\
  [\_meta](#textresourcecontents-_meta)?: [MetaObject](#metaobject);\
  [text](#textresourcecontents-text): string;\
}<details><summary>Example: Text file contents[Permalink](#textresourcecontents-example-text-file-contents)</summary><pre id="textresourcecontents-example-text-file-contents">`{  "uri": "file:///example.txt",  "mimeType": "text/plain",  "text": "Resource content"} `Copy</pre> </details>uri: string[Permalink](#textresourcecontents-uri)The URI of this resource. Inherited from ResourceContents.urimimeType?: string[Permalink](#textresourcecontents-mimetype)The MIME type of this resource, if known. Inherited from ResourceContents.mimeType\_meta?: MetaObject[Permalink](#textresourcecontents-_meta)Inherited from ResourceContents.\_metatext: string[Permalink](#textresourcecontents-text)The text of the item. This must only be set if the item can actually be represented as text (not binary data).&#x20;

## `completion/complete`

### `CompleteRequest`

interface CompleteRequest \{\
  [jsonrpc](#completerequest-jsonrpc): "2.0";\
  [id](#completerequest-id): [RequestId](#requestid);\
  [method](#completerequest-method): "completion/complete";\
  [params](#completerequest-params): [CompleteRequestParams](#completerequestparams);\
}A request from the client to the server, to ask for completion options. <details><summary>Example: Completion request[Permalink](#completerequest-example-completion-request)</summary><pre id="completerequest-example-completion-request">`{  "jsonrpc": "2.0",  "id": "completion-example",  "method": "completion/complete",  "params": {    "ref": {      "type": "ref/prompt",      "name": "code_review"    },    "argument": {      "name": "language",      "value": "py"    }  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#completerequest-jsonrpc)Inherited from [JSONRPCRequest](#jsonrpcrequest).[jsonrpc](#jsonrpcrequest-jsonrpc)id: RequestId[Permalink](#completerequest-id)Inherited from [JSONRPCRequest](#jsonrpcrequest).[id](#jsonrpcrequest-id)method: "completion/complete"[Permalink](#completerequest-method)Overrides [JSONRPCRequest](#jsonrpcrequest).[method](#jsonrpcrequest-method)params: CompleteRequestParams[Permalink](#completerequest-params)Overrides [JSONRPCRequest](#jsonrpcrequest).[params](#jsonrpcrequest-params)

### `CompleteRequestParams`

interface CompleteRequestParams \{\
  [\_meta](#completerequestparams-_meta)?: [RequestMetaObject](#requestmetaobject);\
  [ref](#completerequestparams-ref): [PromptReference](#promptreference) | [ResourceTemplateReference](#resourcetemplatereference);\
  [argument](#completerequestparams-argument): \{ name: string; value: string };\
  [context](#completerequestparams-context)?: \{ arguments?: \{ \[key: string]: string } };\
}Parameters for a `completion/complete` request. <details><summary>Example: Prompt argument completion[Permalink](#completerequestparams-example-prompt-argument-completion)</summary><pre id="completerequestparams-example-prompt-argument-completion">`{  "ref": {    "type": "ref/prompt",    "name": "code_review"  },  "argument": {    "name": "language",    "value": "py"  }} `Copy</pre> </details><details><summary>Example: Prompt argument completion with context[Permalink](#completerequestparams-example-prompt-argument-completion-with-context)</summary><pre id="completerequestparams-example-prompt-argument-completion-with-context">`{  "ref": {    "type": "ref/prompt",    "name": "code_review"  },  "argument": {    "name": "framework",    "value": "fla"  },  "context": {    "arguments": {      "language": "python"    }  }} `Copy</pre> </details>\_meta?: RequestMetaObject[Permalink](#completerequestparams-_meta)Inherited from [RequestParams](#requestparams).[\_meta](#requestparams-_meta)ref: PromptReference | ResourceTemplateReference[Permalink](#completerequestparams-ref)argument: \{ name: string; value: string }[Permalink](#completerequestparams-argument)The argument's information Type Declaration<ul><li>name: stringThe name of the argument </li><li>value: stringThe value of the argument to use for completion matching. </li></ul>context?: \{ arguments?: \{ \[key: string]: string } }[Permalink](#completerequestparams-context)Additional, optional context for completions Type Declaration<ul><li>`Optional`arguments?: \{ \[key: string]: string }Previously-resolved variables in a URI template or prompt. </li></ul>

### `CompleteResultResponse`

interface CompleteResultResponse \{\
  [jsonrpc](#completeresultresponse-jsonrpc): "2.0";\
  [id](#completeresultresponse-id): [RequestId](#requestid);\
  [result](#completeresultresponse-result): [CompleteResult](#completeresult);\
}A successful response from the server for a [completion/complete](#completerequest) request. <details><summary>Example: Completion result response[Permalink](#completeresultresponse-example-completion-result-response)</summary><pre id="completeresultresponse-example-completion-result-response">`{  "jsonrpc": "2.0",  "id": "completion-example",  "result": {    "completion": {      "values": ["flask"],      "total": 1,      "hasMore": false    }  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#completeresultresponse-jsonrpc)Inherited from [JSONRPCResultResponse](#jsonrpcresultresponse).[jsonrpc](#jsonrpcresultresponse-jsonrpc)id: RequestId[Permalink](#completeresultresponse-id)Inherited from [JSONRPCResultResponse](#jsonrpcresultresponse).[id](#jsonrpcresultresponse-id)result: CompleteResult[Permalink](#completeresultresponse-result)Overrides [JSONRPCResultResponse](#jsonrpcresultresponse).[result](#jsonrpcresultresponse-result)

### `CompleteResult`

interface CompleteResult \{\
  [\_meta](#completeresult-_meta)?: [MetaObject](#metaobject);\
  [completion](#completeresult-completion): \{ values: string\[]; total?: number; hasMore?: boolean };\
  \[key: string]: unknown;\
}The result returned by the server for a [completion/complete](#completerequest) request. <details><summary>Example: Single completion value[Permalink](#completeresult-example-single-completion-value)</summary><pre id="completeresult-example-single-completion-value">`{  "completion": {    "values": ["flask"],    "total": 1,    "hasMore": false  }} `Copy</pre> </details><details><summary>Example: Multiple completion values with more available[Permalink](#completeresult-example-multiple-completion-values-with-more-available)</summary><pre id="completeresult-example-multiple-completion-values-with-more-available">`{  "completion": {    "values": ["python", "pytorch", "pyside"],    "total": 10,    "hasMore": true  }} `Copy</pre> </details>\_meta?: MetaObject[Permalink](#completeresult-_meta)Inherited from [Result](#result).[\_meta](#result-_meta)completion: \{ values: string\[]; total?: number; hasMore?: boolean }[Permalink](#completeresult-completion)Type Declaration<ul><li>values: string\[]An array of completion values. Must not exceed 100 items. </li><li>`Optional`total?: numberThe total number of completion options available. This can exceed the number of values actually sent in the response. </li><li>`Optional`hasMore?: booleanIndicates whether there are additional completion options beyond those provided in the current response, even if the exact total is unknown. </li></ul>

### `PromptReference`

interface PromptReference \{\
  [name](#promptreference-name): string;\
  [title](#promptreference-title)?: string;\
  [type](#promptreference-type): "ref/prompt";\
}Identifies a prompt. name: string[Permalink](#promptreference-name)Intended for programmatic or logical use, but used as a display name in past specs or fallback (if title isn't present). Inherited from BaseMetadata.nametitle?: string[Permalink](#promptreference-title)Intended for UI and end-user contexts — optimized to be human-readable and easily understood,
even by those unfamiliar with domain-specific terminology. If not provided, the name should be used for display (except for [Tool](#tool),
where `annotations.title` should be given precedence over using `name`,
if present). Inherited from BaseMetadata.titletype: "ref/prompt"[Permalink](#promptreference-type)

### `ResourceTemplateReference`

interface ResourceTemplateReference \{\
  [type](#resourcetemplatereference-type): "ref/resource";\
  [uri](#resourcetemplatereference-uri): string;\
}A reference to a resource or resource template definition. type: "ref/resource"[Permalink](#resourcetemplatereference-type)uri: string[Permalink](#resourcetemplatereference-uri)The URI or URI template of the resource.&#x20;

## `elicitation/create`

### `ElicitRequest`

interface ElicitRequest \{\
  [jsonrpc](#elicitrequest-jsonrpc): "2.0";\
  [id](#elicitrequest-id): [RequestId](#requestid);\
  [method](#elicitrequest-method): "elicitation/create";\
  [params](#elicitrequest-params): [ElicitRequestParams](#elicitrequestparams);\
}A request from the server to elicit additional information from the user via the client. <details><summary>Example: Elicitation request[Permalink](#elicitrequest-example-elicitation-request)</summary><pre id="elicitrequest-example-elicitation-request">`{  "jsonrpc": "2.0",  "id": "elicitation-example",  "method": "elicitation/create",  "params": {    "mode": "form",    "message": "Please provide your GitHub username",    "requestedSchema": {      "type": "object",      "properties": {        "name": {          "type": "string"        }      },      "required": ["name"]    }  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#elicitrequest-jsonrpc)Inherited from [JSONRPCRequest](#jsonrpcrequest).[jsonrpc](#jsonrpcrequest-jsonrpc)id: RequestId[Permalink](#elicitrequest-id)Inherited from [JSONRPCRequest](#jsonrpcrequest).[id](#jsonrpcrequest-id)method: "elicitation/create"[Permalink](#elicitrequest-method)Overrides [JSONRPCRequest](#jsonrpcrequest).[method](#jsonrpcrequest-method)params: ElicitRequestParams[Permalink](#elicitrequest-params)Overrides [JSONRPCRequest](#jsonrpcrequest).[params](#jsonrpcrequest-params)

### `ElicitRequestParams`

ElicitRequestParams: [ElicitRequestFormParams](#elicitrequestformparams) | [ElicitRequestURLParams](#elicitrequesturlparams)The parameters for a request to elicit additional information from the user via the client.&#x20;

### `ElicitResultResponse`

interface ElicitResultResponse \{\
  [jsonrpc](#elicitresultresponse-jsonrpc): "2.0";\
  [id](#elicitresultresponse-id): [RequestId](#requestid);\
  [result](#elicitresultresponse-result): [ElicitResult](#elicitresult);\
}A successful response from the client for a [elicitation/create](#elicitrequest) request. <details><summary>Example: Elicitation result response[Permalink](#elicitresultresponse-example-elicitation-result-response)</summary><pre id="elicitresultresponse-example-elicitation-result-response">`{  "jsonrpc": "2.0",  "id": "elicitation-example",  "result": {    "action": "accept",    "content": {      "name": "octocat"    }  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#elicitresultresponse-jsonrpc)Inherited from [JSONRPCResultResponse](#jsonrpcresultresponse).[jsonrpc](#jsonrpcresultresponse-jsonrpc)id: RequestId[Permalink](#elicitresultresponse-id)Inherited from [JSONRPCResultResponse](#jsonrpcresultresponse).[id](#jsonrpcresultresponse-id)result: ElicitResult[Permalink](#elicitresultresponse-result)Overrides [JSONRPCResultResponse](#jsonrpcresultresponse).[result](#jsonrpcresultresponse-result)

### `ElicitResult`

interface ElicitResult \{\
  [\_meta](#elicitresult-_meta)?: [MetaObject](#metaobject);\
  [action](#elicitresult-action): "accept" | "decline" | "cancel";\
  [content](#elicitresult-content)?: \{ \[key: string]: string | number | boolean | string\[] };\
  \[key: string]: unknown;\
}The result returned by the client for an [elicitation/create](#elicitrequest) request. <details><summary>Example: Input single field[Permalink](#elicitresult-example-input-single-field)</summary><pre id="elicitresult-example-input-single-field">`{  "action": "accept",  "content": {    "name": "octocat"  }} `Copy</pre> </details><details><summary>Example: Input multiple fields[Permalink](#elicitresult-example-input-multiple-fields)</summary><pre id="elicitresult-example-input-multiple-fields">`{  "action": "accept",  "content": {    "name": "Monalisa Octocat",    "email": "octocat@github.com",    "age": 30  }} `Copy</pre> </details><details><summary>Example: Accept URL mode (no content)[Permalink](#elicitresult-example-accept-url-mode-no-content)</summary><pre id="elicitresult-example-accept-url-mode-no-content">`{  "action": "accept"} `Copy</pre> </details>\_meta?: MetaObject[Permalink](#elicitresult-_meta)Inherited from [Result](#result).[\_meta](#result-_meta)action: "accept" | "decline" | "cancel"[Permalink](#elicitresult-action)The user action in response to the elicitation. <ul> <li>`"accept"`: User submitted the form/confirmed the action</li> <li>`"decline"`: User explicitly declined the action</li> <li>`"cancel"`: User dismissed without making an explicit choice</li> </ul> content?: \{ \[key: string]: string | number | boolean | string\[] }[Permalink](#elicitresult-content)The submitted form data, only present when action is `"accept"` and mode was `"form"`.
Contains values matching the requested schema.
Omitted for out-of-band mode responses.&#x20;

### `BooleanSchema`

interface BooleanSchema \{\
  [type](#booleanschema-type): "boolean";\
  [title](#booleanschema-title)?: string;\
  [description](#booleanschema-description)?: string;\
  [default](#booleanschema-default)?: boolean;\
}<details><summary>Example: Boolean input schema[Permalink](#booleanschema-example-boolean-input-schema)</summary><pre id="booleanschema-example-boolean-input-schema">`{  "type": "boolean",  "title": "Display Name",  "description": "Description text",  "default": false} `Copy</pre> </details>type: "boolean"[Permalink](#booleanschema-type)title?: string[Permalink](#booleanschema-title)description?: string[Permalink](#booleanschema-description)default?: boolean[Permalink](#booleanschema-default)

### `ElicitRequestFormParams`

interface ElicitRequestFormParams \{\
  [task](#elicitrequestformparams-task)?: [TaskMetadata](#taskmetadata);\
  [\_meta](#elicitrequestformparams-_meta)?: [RequestMetaObject](#requestmetaobject);\
  [mode](#elicitrequestformparams-mode)?: "form";\
  [message](#elicitrequestformparams-message): string;\
  [requestedSchema](#elicitrequestformparams-requestedschema): \{\
    \$schema?: string;\
    type: "object";\
    properties: \{ \[key: string]: [PrimitiveSchemaDefinition](#primitiveschemadefinition) };\
    required?: string\[];\
  };\
}The parameters for a request to elicit non-sensitive information from the user via a form in the client. <details><summary>Example: Elicit single field[Permalink](#elicitrequestformparams-example-elicit-single-field)</summary><pre id="elicitrequestformparams-example-elicit-single-field">`{  "mode": "form",  "message": "Please provide your GitHub username",  "requestedSchema": {    "type": "object",    "properties": {      "name": {        "type": "string"      }    },    "required": ["name"]  }} `Copy</pre> </details><details><summary>Example: Elicit multiple fields[Permalink](#elicitrequestformparams-example-elicit-multiple-fields)</summary><pre id="elicitrequestformparams-example-elicit-multiple-fields">`{  "mode": "form",  "message": "Please provide your contact information",  "requestedSchema": {    "type": "object",    "properties": {      "name": {        "type": "string",        "description": "Your full name"      },      "email": {        "type": "string",        "format": "email",        "description": "Your email address"      },      "age": {        "type": "number",        "minimum": 18,        "description": "Your age"      }    },    "required": ["name", "email"]  }} `Copy</pre> </details>task?: TaskMetadata[Permalink](#elicitrequestformparams-task)If specified, the caller is requesting task-augmented execution for this request.
The request will return a [CreateTaskResult](#createtaskresult) immediately, and the actual result can be
retrieved later via [tasks/result](#gettaskpayloadrequest). Task augmentation is subject to capability negotiation - receivers MUST declare support
for task augmentation of specific request types in their capabilities. Inherited from TaskAugmentedRequestParams.task\_meta?: RequestMetaObject[Permalink](#elicitrequestformparams-_meta)Inherited from TaskAugmentedRequestParams.\_metamode?: "form"[Permalink](#elicitrequestformparams-mode)The elicitation mode. message: string[Permalink](#elicitrequestformparams-message)The message to present to the user describing what information is being requested. requestedSchema: \{    \$schema?: string;    type: "object";    properties: \{ \[key: string]: PrimitiveSchemaDefinition };    required?: string\[]; }[Permalink](#elicitrequestformparams-requestedschema)A restricted subset of JSON Schema.
Only top-level properties are allowed, without nesting.&#x20;

### `ElicitRequestURLParams`

interface ElicitRequestURLParams \{\
  [task](#elicitrequesturlparams-task)?: [TaskMetadata](#taskmetadata);\
  [\_meta](#elicitrequesturlparams-_meta)?: [RequestMetaObject](#requestmetaobject);\
  [mode](#elicitrequesturlparams-mode): "url";\
  [message](#elicitrequesturlparams-message): string;\
  [elicitationId](#elicitrequesturlparams-elicitationid): string;\
  [url](#elicitrequesturlparams-url): string;\
}The parameters for a request to elicit information from the user via a URL in the client. <details><summary>Example: Elicit sensitive data[Permalink](#elicitrequesturlparams-example-elicit-sensitive-data)</summary><pre id="elicitrequesturlparams-example-elicit-sensitive-data">`{  "mode": "url",  "elicitationId": "550e8400-e29b-41d4-a716-446655440000",  "url": "https://mcp.example.com/ui/set&#x5F;api&#x5F;key",  "message": "Please provide your API key to continue."} `Copy</pre> </details>task?: TaskMetadata[Permalink](#elicitrequesturlparams-task)If specified, the caller is requesting task-augmented execution for this request.
The request will return a [CreateTaskResult](#createtaskresult) immediately, and the actual result can be
retrieved later via [tasks/result](#gettaskpayloadrequest). Task augmentation is subject to capability negotiation - receivers MUST declare support
for task augmentation of specific request types in their capabilities. Inherited from TaskAugmentedRequestParams.task\_meta?: RequestMetaObject[Permalink](#elicitrequesturlparams-_meta)Inherited from TaskAugmentedRequestParams.\_metamode: "url"[Permalink](#elicitrequesturlparams-mode)The elicitation mode. message: string[Permalink](#elicitrequesturlparams-message)The message to present to the user explaining why the interaction is needed. elicitationId: string[Permalink](#elicitrequesturlparams-elicitationid)The ID of the elicitation, which must be unique within the context of the server.
The client MUST treat this ID as an opaque value. url: string[Permalink](#elicitrequesturlparams-url)The URL that the user should navigate to.&#x20;

### `EnumSchema`

EnumSchema:\
  | [SingleSelectEnumSchema](#singleselectenumschema)\
  | [MultiSelectEnumSchema](#multiselectenumschema)\
  | [LegacyTitledEnumSchema](#legacytitledenumschema)

### `LegacyTitledEnumSchema`

interface LegacyTitledEnumSchema \{\
  [type](#legacytitledenumschema-type): "string";\
  [title](#legacytitledenumschema-title)?: string;\
  [description](#legacytitledenumschema-description)?: string;\
  [enum](#legacytitledenumschema-enum): string\[];\
  [enumNames](#legacytitledenumschema-enumnames)?: string\[];\
  [default](#legacytitledenumschema-default)?: string;\
}Use [TitledSingleSelectEnumSchema](#titledsingleselectenumschema) instead.
This interface will be removed in a future version. type: "string"[Permalink](#legacytitledenumschema-type)title?: string[Permalink](#legacytitledenumschema-title)description?: string[Permalink](#legacytitledenumschema-description)enum: string\[][Permalink](#legacytitledenumschema-enum)enumNames?: string\[][Permalink](#legacytitledenumschema-enumnames)(Legacy) Display names for enum values.
Non-standard according to JSON schema 2020-12. default?: string[Permalink](#legacytitledenumschema-default)

### `MultiSelectEnumSchema`

MultiSelectEnumSchema:\
  | [UntitledMultiSelectEnumSchema](#untitledmultiselectenumschema)\
  | [TitledMultiSelectEnumSchema](#titledmultiselectenumschema)

### `NumberSchema`

interface NumberSchema \{\
  [type](#numberschema-type): "number" | "integer";\
  [title](#numberschema-title)?: string;\
  [description](#numberschema-description)?: string;\
  [minimum](#numberschema-minimum)?: number;\
  [maximum](#numberschema-maximum)?: number;\
  [default](#numberschema-default)?: number;\
}<details><summary>Example: Number input schema[Permalink](#numberschema-example-number-input-schema)</summary><pre id="numberschema-example-number-input-schema">`{  "type": "number",  "title": "Display Name",  "description": "Description text",  "minimum": 0,  "maximum": 100,  "default": 50} `Copy</pre> </details>type: "number" | "integer"[Permalink](#numberschema-type)title?: string[Permalink](#numberschema-title)description?: string[Permalink](#numberschema-description)minimum?: number[Permalink](#numberschema-minimum)maximum?: number[Permalink](#numberschema-maximum)default?: number[Permalink](#numberschema-default)

### `PrimitiveSchemaDefinition`

PrimitiveSchemaDefinition:\
  | [StringSchema](#stringschema)\
  | [NumberSchema](#numberschema)\
  | [BooleanSchema](#booleanschema)\
  | [EnumSchema](#enumschema)Restricted schema definitions that only allow primitive types
without nested objects or arrays.&#x20;

### `SingleSelectEnumSchema`

SingleSelectEnumSchema:\
  | [UntitledSingleSelectEnumSchema](#untitledsingleselectenumschema)\
  | [TitledSingleSelectEnumSchema](#titledsingleselectenumschema)

### `StringSchema`

interface StringSchema \{\
  [type](#stringschema-type): "string";\
  [title](#stringschema-title)?: string;\
  [description](#stringschema-description)?: string;\
  [minLength](#stringschema-minlength)?: number;\
  [maxLength](#stringschema-maxlength)?: number;\
  [format](#stringschema-format)?: "uri" | "email" | "date" | "date-time";\
  [default](#stringschema-default)?: string;\
}<details><summary>Example: Email input schema[Permalink](#stringschema-example-email-input-schema)</summary><pre id="stringschema-example-email-input-schema">`{  "type": "string",  "title": "Display Name",  "description": "Description text",  "minLength": 3,  "maxLength": 50,  "format": "email",  "default": "user@example.com"} `Copy</pre> </details>type: "string"[Permalink](#stringschema-type)title?: string[Permalink](#stringschema-title)description?: string[Permalink](#stringschema-description)minLength?: number[Permalink](#stringschema-minlength)maxLength?: number[Permalink](#stringschema-maxlength)format?: "uri" | "email" | "date" | "date-time"[Permalink](#stringschema-format)default?: string[Permalink](#stringschema-default)

### `TitledMultiSelectEnumSchema`

interface TitledMultiSelectEnumSchema \{\
  [type](#titledmultiselectenumschema-type): "array";\
  [title](#titledmultiselectenumschema-title)?: string;\
  [description](#titledmultiselectenumschema-description)?: string;\
  [minItems](#titledmultiselectenumschema-minitems)?: number;\
  [maxItems](#titledmultiselectenumschema-maxitems)?: number;\
  [items](#titledmultiselectenumschema-items): \{ anyOf: \{ const: string; title: string }\[] };\
  [default](#titledmultiselectenumschema-default)?: string\[];\
}Schema for multiple-selection enumeration with display titles for each option. <details><summary>Example: Titled color multi-select schema[Permalink](#titledmultiselectenumschema-example-titled-color-multi-select-schema)</summary><pre id="titledmultiselectenumschema-example-titled-color-multi-select-schema">`{  "type": "array",  "title": "Color Selection",  "description": "Choose your favorite colors",  "minItems": 1,  "maxItems": 2,  "items": {    "anyOf": [      { "const": "#FF0000", "title": "Red" },      { "const": "#00FF00", "title": "Green" },      { "const": "#0000FF", "title": "Blue" }    ]  },  "default": ["#FF0000", "#00FF00"]} `Copy</pre> </details>type: "array"[Permalink](#titledmultiselectenumschema-type)title?: string[Permalink](#titledmultiselectenumschema-title)Optional title for the enum field. description?: string[Permalink](#titledmultiselectenumschema-description)Optional description for the enum field. minItems?: number[Permalink](#titledmultiselectenumschema-minitems)Minimum number of items to select. maxItems?: number[Permalink](#titledmultiselectenumschema-maxitems)Maximum number of items to select. items: \{ anyOf: \{ const: string; title: string }\[] }[Permalink](#titledmultiselectenumschema-items)Schema for array items with enum options and display labels. Type Declaration<ul><li>anyOf: \{ const: string; title: string }\[]Array of enum options with values and display labels. </li></ul>default?: string\[][Permalink](#titledmultiselectenumschema-default)Optional default value.&#x20;

### `TitledSingleSelectEnumSchema`

interface TitledSingleSelectEnumSchema \{\
  [type](#titledsingleselectenumschema-type): "string";\
  [title](#titledsingleselectenumschema-title)?: string;\
  [description](#titledsingleselectenumschema-description)?: string;\
  [oneOf](#titledsingleselectenumschema-oneof): \{ const: string; title: string }\[];\
  [default](#titledsingleselectenumschema-default)?: string;\
}Schema for single-selection enumeration with display titles for each option. <details><summary>Example: Titled color select schema[Permalink](#titledsingleselectenumschema-example-titled-color-select-schema)</summary><pre id="titledsingleselectenumschema-example-titled-color-select-schema">`{  "type": "string",  "title": "Color Selection",  "description": "Choose your favorite color",  "oneOf": [    { "const": "#FF0000", "title": "Red" },    { "const": "#00FF00", "title": "Green" },    { "const": "#0000FF", "title": "Blue" }  ],  "default": "#FF0000"} `Copy</pre> </details>type: "string"[Permalink](#titledsingleselectenumschema-type)title?: string[Permalink](#titledsingleselectenumschema-title)Optional title for the enum field. description?: string[Permalink](#titledsingleselectenumschema-description)Optional description for the enum field. oneOf: \{ const: string; title: string }\[][Permalink](#titledsingleselectenumschema-oneof)Array of enum options with values and display labels. Type Declaration<ul><li>const: stringThe enum value. </li><li>title: stringDisplay label for this option. </li></ul>default?: string[Permalink](#titledsingleselectenumschema-default)Optional default value.&#x20;

### `UntitledMultiSelectEnumSchema`

interface UntitledMultiSelectEnumSchema \{\
  [type](#untitledmultiselectenumschema-type): "array";\
  [title](#untitledmultiselectenumschema-title)?: string;\
  [description](#untitledmultiselectenumschema-description)?: string;\
  [minItems](#untitledmultiselectenumschema-minitems)?: number;\
  [maxItems](#untitledmultiselectenumschema-maxitems)?: number;\
  [items](#untitledmultiselectenumschema-items): \{ type: "string"; enum: string\[] };\
  [default](#untitledmultiselectenumschema-default)?: string\[];\
}Schema for multiple-selection enumeration without display titles for options. <details><summary>Example: Color multi-select schema[Permalink](#untitledmultiselectenumschema-example-color-multi-select-schema)</summary><pre id="untitledmultiselectenumschema-example-color-multi-select-schema">`{  "type": "array",  "title": "Color Selection",  "description": "Choose your favorite colors",  "minItems": 1,  "maxItems": 2,  "items": {    "type": "string",    "enum": ["Red", "Green", "Blue"]  },  "default": ["Red", "Green"]} `Copy</pre> </details>type: "array"[Permalink](#untitledmultiselectenumschema-type)title?: string[Permalink](#untitledmultiselectenumschema-title)Optional title for the enum field. description?: string[Permalink](#untitledmultiselectenumschema-description)Optional description for the enum field. minItems?: number[Permalink](#untitledmultiselectenumschema-minitems)Minimum number of items to select. maxItems?: number[Permalink](#untitledmultiselectenumschema-maxitems)Maximum number of items to select. items: \{ type: "string"; enum: string\[] }[Permalink](#untitledmultiselectenumschema-items)Schema for the array items. Type Declaration<ul><li>type: "string"</li><li>enum: string\[]Array of enum values to choose from. </li></ul>default?: string\[][Permalink](#untitledmultiselectenumschema-default)Optional default value.&#x20;

### `UntitledSingleSelectEnumSchema`

interface UntitledSingleSelectEnumSchema \{\
  [type](#untitledsingleselectenumschema-type): "string";\
  [title](#untitledsingleselectenumschema-title)?: string;\
  [description](#untitledsingleselectenumschema-description)?: string;\
  [enum](#untitledsingleselectenumschema-enum): string\[];\
  [default](#untitledsingleselectenumschema-default)?: string;\
}Schema for single-selection enumeration without display titles for options. <details><summary>Example: Color select schema[Permalink](#untitledsingleselectenumschema-example-color-select-schema)</summary><pre id="untitledsingleselectenumschema-example-color-select-schema">`{  "type": "string",  "title": "Color Selection",  "description": "Choose your favorite color",  "enum": ["Red", "Green", "Blue"],  "default": "Red"} `Copy</pre> </details>type: "string"[Permalink](#untitledsingleselectenumschema-type)title?: string[Permalink](#untitledsingleselectenumschema-title)Optional title for the enum field. description?: string[Permalink](#untitledsingleselectenumschema-description)Optional description for the enum field. enum: string\[][Permalink](#untitledsingleselectenumschema-enum)Array of enum values to choose from. default?: string[Permalink](#untitledsingleselectenumschema-default)Optional default value.&#x20;

## `initialize`

### `InitializeRequest`

interface InitializeRequest \{\
  [jsonrpc](#initializerequest-jsonrpc): "2.0";\
  [id](#initializerequest-id): [RequestId](#requestid);\
  [method](#initializerequest-method): "initialize";\
  [params](#initializerequest-params): [InitializeRequestParams](#initializerequestparams);\
}This request is sent from the client to the server when it first connects, asking it to begin initialization. <details><summary>Example: Initialize request[Permalink](#initializerequest-example-initialize-request)</summary><pre id="initializerequest-example-initialize-request">`{  "jsonrpc": "2.0",  "id": "initialize-example",  "method": "initialize",  "params": {    "protocolVersion": "2024-11-05",    "capabilities": {      "roots": {        "listChanged": true      },      "sampling": {},      "elicitation": {        "form": {},        "url": {}      },      "tasks": {        "requests": {          "elicitation": {            "create": {}          },          "sampling": {            "createMessage": {}          }        }      }    },    "clientInfo": {      "name": "ExampleClient",      "title": "Example Client Display Name",      "version": "1.0.0",      "description": "An example MCP client application",      "icons": [        {          "src": "https://example.com/icon.png",          "mimeType": "image/png",          "sizes": ["48x48"]        }      ],      "websiteUrl": "https://example.com"    }  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#initializerequest-jsonrpc)Inherited from [JSONRPCRequest](#jsonrpcrequest).[jsonrpc](#jsonrpcrequest-jsonrpc)id: RequestId[Permalink](#initializerequest-id)Inherited from [JSONRPCRequest](#jsonrpcrequest).[id](#jsonrpcrequest-id)method: "initialize"[Permalink](#initializerequest-method)Overrides [JSONRPCRequest](#jsonrpcrequest).[method](#jsonrpcrequest-method)params: InitializeRequestParams[Permalink](#initializerequest-params)Overrides [JSONRPCRequest](#jsonrpcrequest).[params](#jsonrpcrequest-params)

### `InitializeRequestParams`

interface InitializeRequestParams \{\
  [\_meta](#initializerequestparams-_meta)?: [RequestMetaObject](#requestmetaobject);\
  [protocolVersion](#initializerequestparams-protocolversion): string;\
  [capabilities](#initializerequestparams-capabilities): [ClientCapabilities](#clientcapabilities);\
  [clientInfo](#initializerequestparams-clientinfo): [Implementation](#implementation);\
}Parameters for an `initialize` request. <details><summary>Example: Full client capabilities[Permalink](#initializerequestparams-example-full-client-capabilities)</summary><pre id="initializerequestparams-example-full-client-capabilities">`{  "protocolVersion": "2024-11-05",  "capabilities": {    "roots": {      "listChanged": true    },    "sampling": {},    "elicitation": {      "form": {},      "url": {}    },    "tasks": {      "requests": {        "elicitation": {          "create": {}        },        "sampling": {          "createMessage": {}        }      }    }  },  "clientInfo": {    "name": "ExampleClient",    "title": "Example Client Display Name",    "version": "1.0.0",    "description": "An example MCP client application",    "icons": [      {        "src": "https://example.com/icon.png",        "mimeType": "image/png",        "sizes": ["48x48"]      }    ],    "websiteUrl": "https://example.com"  }} `Copy</pre> </details>\_meta?: RequestMetaObject[Permalink](#initializerequestparams-_meta)Inherited from [RequestParams](#requestparams).[\_meta](#requestparams-_meta)protocolVersion: string[Permalink](#initializerequestparams-protocolversion)The latest version of the Model Context Protocol that the client supports. The client MAY decide to support older versions as well. capabilities: ClientCapabilities[Permalink](#initializerequestparams-capabilities)clientInfo: Implementation[Permalink](#initializerequestparams-clientinfo)

### `InitializeResultResponse`

interface InitializeResultResponse \{\
  [jsonrpc](#initializeresultresponse-jsonrpc): "2.0";\
  [id](#initializeresultresponse-id): [RequestId](#requestid);\
  [result](#initializeresultresponse-result): [InitializeResult](#initializeresult);\
}A successful response from the server for a [initialize](#initializerequest) request. <details><summary>Example: Initialize result response[Permalink](#initializeresultresponse-example-initialize-result-response)</summary><pre id="initializeresultresponse-example-initialize-result-response">`{  "jsonrpc": "2.0",  "id": "initialize-example",  "result": {    "protocolVersion": "2024-11-05",    "capabilities": {      "logging": {},      "prompts": {        "listChanged": true      },      "resources": {        "subscribe": true,        "listChanged": true      },      "tools": {        "listChanged": true      },      "tasks": {        "list": {},        "cancel": {},        "requests": {          "tools": {            "call": {}          }        }      }    },    "serverInfo": {      "name": "ExampleServer",      "title": "Example Server Display Name",      "version": "1.0.0",      "description": "An example MCP server providing tools and resources",      "icons": [        {          "src": "https://example.com/server-icon.svg",          "mimeType": "image/svg+xml",          "sizes": ["any"]        }      ],      "websiteUrl": "https://example.com/server"    },    "instructions": "Optional instructions for the client"  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#initializeresultresponse-jsonrpc)Inherited from [JSONRPCResultResponse](#jsonrpcresultresponse).[jsonrpc](#jsonrpcresultresponse-jsonrpc)id: RequestId[Permalink](#initializeresultresponse-id)Inherited from [JSONRPCResultResponse](#jsonrpcresultresponse).[id](#jsonrpcresultresponse-id)result: InitializeResult[Permalink](#initializeresultresponse-result)Overrides [JSONRPCResultResponse](#jsonrpcresultresponse).[result](#jsonrpcresultresponse-result)

### `InitializeResult`

interface InitializeResult \{\
  [\_meta](#initializeresult-_meta)?: [MetaObject](#metaobject);\
  [protocolVersion](#initializeresult-protocolversion): string;\
  [capabilities](#initializeresult-capabilities): [ServerCapabilities](#servercapabilities);\
  [serverInfo](#initializeresult-serverinfo): [Implementation](#implementation);\
  [instructions](#initializeresult-instructions)?: string;\
  \[key: string]: unknown;\
}The result returned by the server for an [initialize](#initializerequest) request. <details><summary>Example: Full server capabilities[Permalink](#initializeresult-example-full-server-capabilities)</summary><pre id="initializeresult-example-full-server-capabilities">`{  "protocolVersion": "2024-11-05",  "capabilities": {    "logging": {},    "prompts": {      "listChanged": true    },    "resources": {      "subscribe": true,      "listChanged": true    },    "tools": {      "listChanged": true    },    "tasks": {      "list": {},      "cancel": {},      "requests": {        "tools": {          "call": {}        }      }    }  },  "serverInfo": {    "name": "ExampleServer",    "title": "Example Server Display Name",    "version": "1.0.0",    "description": "An example MCP server providing tools and resources",    "icons": [      {        "src": "https://example.com/server-icon.svg",        "mimeType": "image/svg+xml",        "sizes": ["any"]      }    ],    "websiteUrl": "https://example.com/server"  },  "instructions": "Optional instructions for the client"} `Copy</pre> </details>\_meta?: MetaObject[Permalink](#initializeresult-_meta)Inherited from [Result](#result).[\_meta](#result-_meta)protocolVersion: string[Permalink](#initializeresult-protocolversion)The version of the Model Context Protocol that the server wants to use. This may not match the version that the client requested. If the client cannot support this version, it MUST disconnect. capabilities: ServerCapabilities[Permalink](#initializeresult-capabilities)serverInfo: Implementation[Permalink](#initializeresult-serverinfo)instructions?: string[Permalink](#initializeresult-instructions)Instructions describing how to use the server and its features. This can be used by clients to improve the LLM's understanding of available tools, resources, etc. It can be thought of like a "hint" to the model. For example, this information MAY be added to the system prompt.&#x20;

### `ClientCapabilities`

interface ClientCapabilities \{\
  [experimental](#clientcapabilities-experimental)?: \{ \[key: string]: object };\
  [roots](#clientcapabilities-roots)?: \{ listChanged?: boolean };\
  [sampling](#clientcapabilities-sampling)?: \{ context?: object; tools?: object };\
  [elicitation](#clientcapabilities-elicitation)?: \{ form?: object; url?: object };\
  [tasks](#clientcapabilities-tasks)?: \{\
    list?: object;\
    cancel?: object;\
    requests?: \{\
      sampling?: \{ createMessage?: object };\
      elicitation?: \{ create?: object };\
    };\
  };\
  [extensions](#clientcapabilities-extensions)?: \{ \[key: string]: object };\
}Capabilities a client may support. Known capabilities are defined here, in this schema, but this is not a closed set: any client can define its own, additional capabilities. experimental?: \{ \[key: string]: object }[Permalink](#clientcapabilities-experimental)Experimental, non-standard capabilities that the client supports. roots?: \{ listChanged?: boolean }[Permalink](#clientcapabilities-roots)Present if the client supports listing roots. Type Declaration<ul><li>`Optional`listChanged?: booleanWhether the client supports notifications for changes to the roots list. </li></ul><details><summary>Example: Roots — minimum baseline support[Permalink](#clientcapabilities-example-roots-minimum-baseline-support)</summary><pre id="clientcapabilities-example-roots-minimum-baseline-support">`{  "roots": {}} `Copy</pre> </details><details><summary>Example: Roots — list changed notifications[Permalink](#clientcapabilities-example-roots-list-changed-notifications)</summary><pre id="clientcapabilities-example-roots-list-changed-notifications">`{  "roots": {    "listChanged": true  }} `Copy</pre> </details>sampling?: \{ context?: object; tools?: object }[Permalink](#clientcapabilities-sampling)Present if the client supports sampling from an LLM. Type Declaration<ul><li>`Optional`context?: objectWhether the client supports context inclusion via `includeContext` parameter.
If not declared, servers SHOULD only use `includeContext: "none"` (or omit it). </li><li>`Optional`tools?: objectWhether the client supports tool use via `tools` and `toolChoice` parameters. </li></ul><details><summary>Example: Sampling — minimum baseline support[Permalink](#clientcapabilities-example-sampling-minimum-baseline-support)</summary><pre id="clientcapabilities-example-sampling-minimum-baseline-support">`{  "sampling": {}} `Copy</pre> </details><details><summary>Example: Sampling — tool use support[Permalink](#clientcapabilities-example-sampling-tool-use-support)</summary><pre id="clientcapabilities-example-sampling-tool-use-support">`{  "sampling": {    "tools": {}  }} `Copy</pre> </details><details><summary>Example: Sampling — context inclusion support (soft-deprecated)[Permalink](#clientcapabilities-example-sampling-context-inclusion-support-soft-deprecated)</summary><pre id="clientcapabilities-example-sampling-context-inclusion-support-soft-deprecated">`{  "sampling": {    "context": {}  }} `Copy</pre> </details>elicitation?: \{ form?: object; url?: object }[Permalink](#clientcapabilities-elicitation)Present if the client supports elicitation from the server. <details><summary>Example: Elicitation — form and URL mode support[Permalink](#clientcapabilities-example-elicitation-form-and-url-mode-support)</summary><pre id="clientcapabilities-example-elicitation-form-and-url-mode-support">`{  "elicitation": {    "form": {},    "url": {}  }} `Copy</pre> </details><details><summary>Example: Elicitation — form mode only (implicit)[Permalink](#clientcapabilities-example-elicitation-form-mode-only-implicit)</summary><pre id="clientcapabilities-example-elicitation-form-mode-only-implicit">`{  "elicitation": {}} `Copy</pre> </details>tasks?: \{    list?: object;    cancel?: object;    requests?: \{        sampling?: \{ createMessage?: object };        elicitation?: \{ create?: object };    }; }[Permalink](#clientcapabilities-tasks)Present if the client supports task-augmented requests. Type Declaration<ul><li>`Optional`list?: objectWhether this client supports [tasks/list](#listtasksrequest). </li><li>`Optional`cancel?: objectWhether this client supports [tasks/cancel](#canceltaskrequest). </li><li>`Optional`requests?: \{ sampling?: \{ createMessage?: object }; elicitation?: \{ create?: object } }Specifies which request types can be augmented with tasks. <ul><li>`Optional`sampling?: \{ createMessage?: object }Task support for sampling-related requests. <ul><li>`Optional`createMessage?: objectWhether the client supports task-augmented `sampling/createMessage` requests. </li></ul></li><li>`Optional`elicitation?: \{ create?: object }Task support for elicitation-related requests. <ul><li>`Optional`create?: objectWhether the client supports task-augmented [elicitation/create](#elicitrequest) requests. </li></ul></li></ul></li></ul>extensions?: \{ \[key: string]: object }[Permalink](#clientcapabilities-extensions)Optional MCP extensions that the client supports. Keys are extension identifiers
(e.g., "io.modelcontextprotocol/oauth-client-credentials"), and values are
per-extension settings objects. An empty object indicates support with no settings. <details><summary>Example: Extensions — UI extension with MIME type support[Permalink](#clientcapabilities-example-extensions-ui-extension-with-mime-type-support)</summary><pre id="clientcapabilities-example-extensions-ui-extension-with-mime-type-support">`{  "extensions": {    "io.modelcontextprotocol/apps": {      "mimeTypes": ["text/html;profile=mcp-app"]    }  }} `Copy</pre> </details>

### `Implementation`

interface Implementation \{\
  [icons](#implementation-icons)?: [Icon](#icon)\[];\
  [name](#implementation-name): string;\
  [title](#implementation-title)?: string;\
  [version](#implementation-version): string;\
  [description](#implementation-description)?: string;\
  [websiteUrl](#implementation-websiteurl)?: string;\
}Describes the MCP implementation. icons?: Icon\[][Permalink](#implementation-icons)Optional set of sized icons that the client can display in a user interface. Clients that support rendering icons MUST support at least the following MIME types: <ul> <li>`image/png` - PNG images (safe, universal compatibility)</li> <li>`image/jpeg` (and `image/jpg`) - JPEG images (safe, universal compatibility)</li> </ul> Clients that support rendering icons SHOULD also support: <ul> <li>`image/svg+xml` - SVG images (scalable but requires security precautions)</li> <li>`image/webp` - WebP images (modern, efficient format)</li> </ul> Inherited from Icons.iconsname: string[Permalink](#implementation-name)Intended for programmatic or logical use, but used as a display name in past specs or fallback (if title isn't present). Inherited from BaseMetadata.nametitle?: string[Permalink](#implementation-title)Intended for UI and end-user contexts — optimized to be human-readable and easily understood,
even by those unfamiliar with domain-specific terminology. If not provided, the name should be used for display (except for [Tool](#tool),
where `annotations.title` should be given precedence over using `name`,
if present). Inherited from BaseMetadata.titleversion: string[Permalink](#implementation-version)The version of this implementation. description?: string[Permalink](#implementation-description)An optional human-readable description of what this implementation does. This can be used by clients or servers to provide context about their purpose
and capabilities. For example, a server might describe the types of resources
or tools it provides, while a client might describe its intended use case. websiteUrl?: string[Permalink](#implementation-websiteurl)An optional URL of the website for this implementation.&#x20;

### `ServerCapabilities`

interface ServerCapabilities \{\
  [experimental](#servercapabilities-experimental)?: \{ \[key: string]: object };\
  [logging](#servercapabilities-logging)?: object;\
  [completions](#servercapabilities-completions)?: object;\
  [prompts](#servercapabilities-prompts)?: \{ listChanged?: boolean };\
  [resources](#servercapabilities-resources)?: \{ subscribe?: boolean; listChanged?: boolean };\
  [tools](#servercapabilities-tools)?: \{ listChanged?: boolean };\
  [tasks](#servercapabilities-tasks)?: \{\
    list?: object;\
    cancel?: object;\
    requests?: \{ tools?: \{ call?: object } };\
  };\
  [extensions](#servercapabilities-extensions)?: \{ \[key: string]: object };\
}Capabilities that a server may support. Known capabilities are defined here, in this schema, but this is not a closed set: any server can define its own, additional capabilities. experimental?: \{ \[key: string]: object }[Permalink](#servercapabilities-experimental)Experimental, non-standard capabilities that the server supports. logging?: object[Permalink](#servercapabilities-logging)Present if the server supports sending log messages to the client. <details><summary>Example: Logging — minimum baseline support[Permalink](#servercapabilities-example-logging-minimum-baseline-support)</summary><pre id="servercapabilities-example-logging-minimum-baseline-support">`{  "logging": {}} `Copy</pre> </details>completions?: object[Permalink](#servercapabilities-completions)Present if the server supports argument autocompletion suggestions. <details><summary>Example: Completions — minimum baseline support[Permalink](#servercapabilities-example-completions-minimum-baseline-support)</summary><pre id="servercapabilities-example-completions-minimum-baseline-support">`{  "completions": {}} `Copy</pre> </details>prompts?: \{ listChanged?: boolean }[Permalink](#servercapabilities-prompts)Present if the server offers any prompt templates. Type Declaration<ul><li>`Optional`listChanged?: booleanWhether this server supports notifications for changes to the prompt list. </li></ul><details><summary>Example: Prompts — minimum baseline support[Permalink](#servercapabilities-example-prompts-minimum-baseline-support)</summary><pre id="servercapabilities-example-prompts-minimum-baseline-support">`{  "prompts": {}} `Copy</pre> </details><details><summary>Example: Prompts — list changed notifications[Permalink](#servercapabilities-example-prompts-list-changed-notifications)</summary><pre id="servercapabilities-example-prompts-list-changed-notifications">`{  "prompts": {    "listChanged": true  }} `Copy</pre> </details>resources?: \{ subscribe?: boolean; listChanged?: boolean }[Permalink](#servercapabilities-resources)Present if the server offers any resources to read. Type Declaration<ul><li>`Optional`subscribe?: booleanWhether this server supports subscribing to resource updates. </li><li>`Optional`listChanged?: booleanWhether this server supports notifications for changes to the resource list. </li></ul><details><summary>Example: Resources — minimum baseline support[Permalink](#servercapabilities-example-resources-minimum-baseline-support)</summary><pre id="servercapabilities-example-resources-minimum-baseline-support">`{  "resources": {}} `Copy</pre> </details><details><summary>Example: Resources — subscription to individual resource updates (only)[Permalink](#servercapabilities-example-resources-subscription-to-individual-resource-updates-only)</summary><pre id="servercapabilities-example-resources-subscription-to-individual-resource-updates-only">`{  "resources": {    "subscribe": true  }} `Copy</pre> </details><details><summary>Example: Resources — list changed notifications (only)[Permalink](#servercapabilities-example-resources-list-changed-notifications-only)</summary><pre id="servercapabilities-example-resources-list-changed-notifications-only">`{  "resources": {    "listChanged": true  }} `Copy</pre> </details><details><summary>Example: Resources — all notifications[Permalink](#servercapabilities-example-resources-all-notifications)</summary><pre id="servercapabilities-example-resources-all-notifications">`{  "resources": {    "subscribe": true,    "listChanged": true  }} `Copy</pre> </details>tools?: \{ listChanged?: boolean }[Permalink](#servercapabilities-tools)Present if the server offers any tools to call. Type Declaration<ul><li>`Optional`listChanged?: booleanWhether this server supports notifications for changes to the tool list. </li></ul><details><summary>Example: Tools — minimum baseline support[Permalink](#servercapabilities-example-tools-minimum-baseline-support)</summary><pre id="servercapabilities-example-tools-minimum-baseline-support">`{  "tools": {}} `Copy</pre> </details><details><summary>Example: Tools — list changed notifications[Permalink](#servercapabilities-example-tools-list-changed-notifications)</summary><pre id="servercapabilities-example-tools-list-changed-notifications">`{  "tools": {    "listChanged": true  }} `Copy</pre> </details>tasks?: \{    list?: object;    cancel?: object;    requests?: \{ tools?: \{ call?: object } }; }[Permalink](#servercapabilities-tasks)Present if the server supports task-augmented requests. Type Declaration<ul><li>`Optional`list?: objectWhether this server supports [tasks/list](#listtasksrequest). </li><li>`Optional`cancel?: objectWhether this server supports [tasks/cancel](#canceltaskrequest). </li><li>`Optional`requests?: \{ tools?: \{ call?: object } }Specifies which request types can be augmented with tasks. <ul><li>`Optional`tools?: \{ call?: object }Task support for tool-related requests. <ul><li>`Optional`call?: objectWhether the server supports task-augmented [tools/call](#calltoolrequest) requests. </li></ul></li></ul></li></ul>extensions?: \{ \[key: string]: object }[Permalink](#servercapabilities-extensions)Optional MCP extensions that the server supports. Keys are extension identifiers
(e.g., "io.modelcontextprotocol/apps"), and values are per-extension settings
objects. An empty object indicates support with no settings. <details><summary>Example: Extensions — UI extension support[Permalink](#servercapabilities-example-extensions-ui-extension-support)</summary><pre id="servercapabilities-example-extensions-ui-extension-support">`{  "extensions": {    "io.modelcontextprotocol/apps": {}  }} `Copy</pre> </details>

## `logging/setLevel`

### `SetLevelRequest`

interface SetLevelRequest \{\
  [jsonrpc](#setlevelrequest-jsonrpc): "2.0";\
  [id](#setlevelrequest-id): [RequestId](#requestid);\
  [method](#setlevelrequest-method): "logging/setLevel";\
  [params](#setlevelrequest-params): [SetLevelRequestParams](#setlevelrequestparams);\
}A request from the client to the server, to enable or adjust logging. <details><summary>Example: Set logging level request[Permalink](#setlevelrequest-example-set-logging-level-request)</summary><pre id="setlevelrequest-example-set-logging-level-request">`{  "jsonrpc": "2.0",  "id": "set-logging-level-example",  "method": "logging/setLevel",  "params": {    "level": "info"  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#setlevelrequest-jsonrpc)Inherited from [JSONRPCRequest](#jsonrpcrequest).[jsonrpc](#jsonrpcrequest-jsonrpc)id: RequestId[Permalink](#setlevelrequest-id)Inherited from [JSONRPCRequest](#jsonrpcrequest).[id](#jsonrpcrequest-id)method: "logging/setLevel"[Permalink](#setlevelrequest-method)Overrides [JSONRPCRequest](#jsonrpcrequest).[method](#jsonrpcrequest-method)params: SetLevelRequestParams[Permalink](#setlevelrequest-params)Overrides [JSONRPCRequest](#jsonrpcrequest).[params](#jsonrpcrequest-params)

### `SetLevelRequestParams`

interface SetLevelRequestParams \{\
  [\_meta](#setlevelrequestparams-_meta)?: [RequestMetaObject](#requestmetaobject);\
  [level](#setlevelrequestparams-level): [LoggingLevel](#logginglevel);\
}Parameters for a `logging/setLevel` request. <details><summary>Example: Set log level to "info"[Permalink](#setlevelrequestparams-example-set-log-level-to-info)</summary><pre id="setlevelrequestparams-example-set-log-level-to-info">`{  "level": "info"} `Copy</pre> </details>\_meta?: RequestMetaObject[Permalink](#setlevelrequestparams-_meta)Inherited from [RequestParams](#requestparams).[\_meta](#requestparams-_meta)level: LoggingLevel[Permalink](#setlevelrequestparams-level)The level of logging that the client wants to receive from the server. The server should send all logs at this level and higher (i.e., more severe) to the client as [notifications/message](#loggingmessagenotification).&#x20;

### `SetLevelResultResponse`

interface SetLevelResultResponse \{\
  [jsonrpc](#setlevelresultresponse-jsonrpc): "2.0";\
  [id](#setlevelresultresponse-id): [RequestId](#requestid);\
  [result](#setlevelresultresponse-result): [Result](#result);\
}A successful response from the server for a [logging/setLevel](#setlevelrequest) request. <details><summary>Example: Set logging level result response[Permalink](#setlevelresultresponse-example-set-logging-level-result-response)</summary><pre id="setlevelresultresponse-example-set-logging-level-result-response">`{  "jsonrpc": "2.0",  "id": "set-logging-level-example",  "result": {}} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#setlevelresultresponse-jsonrpc)Inherited from [JSONRPCResultResponse](#jsonrpcresultresponse).[jsonrpc](#jsonrpcresultresponse-jsonrpc)id: RequestId[Permalink](#setlevelresultresponse-id)Inherited from [JSONRPCResultResponse](#jsonrpcresultresponse).[id](#jsonrpcresultresponse-id)result: Result[Permalink](#setlevelresultresponse-result)Overrides [JSONRPCResultResponse](#jsonrpcresultresponse).[result](#jsonrpcresultresponse-result)

## `notifications/cancelled`

### `CancelledNotification`

interface CancelledNotification \{\
  [jsonrpc](#cancellednotification-jsonrpc): "2.0";\
  [method](#cancellednotification-method): "notifications/cancelled";\
  [params](#cancellednotification-params): [CancelledNotificationParams](#cancellednotificationparams);\
}This notification can be sent by either side to indicate that it is cancelling a previously-issued request. The request SHOULD still be in-flight, but due to communication latency, it is always possible that this notification MAY arrive after the request has already finished. This notification indicates that the result will be unused, so any associated processing SHOULD cease. A client MUST NOT attempt to cancel its `initialize` request. For task cancellation, use the [tasks/cancel](#canceltaskrequest) request instead of this notification. <details><summary>Example: User-requested cancellation[Permalink](#cancellednotification-example-user-requested-cancellation)</summary><pre id="cancellednotification-example-user-requested-cancellation">`{  "jsonrpc": "2.0",  "method": "notifications/cancelled",  "params": {    "requestId": "123",    "reason": "User requested cancellation"  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#cancellednotification-jsonrpc)Inherited from [JSONRPCNotification](#jsonrpcnotification).[jsonrpc](#jsonrpcnotification-jsonrpc)method: "notifications/cancelled"[Permalink](#cancellednotification-method)Overrides [JSONRPCNotification](#jsonrpcnotification).[method](#jsonrpcnotification-method)params: CancelledNotificationParams[Permalink](#cancellednotification-params)Overrides [JSONRPCNotification](#jsonrpcnotification).[params](#jsonrpcnotification-params)

### `CancelledNotificationParams`

interface CancelledNotificationParams \{\
  [\_meta](#cancellednotificationparams-_meta)?: [MetaObject](#metaobject);\
  [requestId](#cancellednotificationparams-requestid)?: [RequestId](#requestid);\
  [reason](#cancellednotificationparams-reason)?: string;\
}Parameters for a `notifications/cancelled` notification. <details><summary>Example: User-requested cancellation[Permalink](#cancellednotificationparams-example-user-requested-cancellation)</summary><pre id="cancellednotificationparams-example-user-requested-cancellation">`{  "requestId": "123",  "reason": "User requested cancellation"} `Copy</pre> </details>\_meta?: MetaObject[Permalink](#cancellednotificationparams-_meta)Inherited from [NotificationParams](#notificationparams).[\_meta](#notificationparams-_meta)requestId?: RequestId[Permalink](#cancellednotificationparams-requestid)The ID of the request to cancel. This MUST correspond to the ID of a request previously issued in the same direction.
This MUST be provided for cancelling non-task requests.
This MUST NOT be used for cancelling tasks (use the [tasks/cancel](#canceltaskrequest) request instead). reason?: string[Permalink](#cancellednotificationparams-reason)An optional string describing the reason for the cancellation. This MAY be logged or presented to the user.&#x20;

## `notifications/initialized`

### `InitializedNotification`

interface InitializedNotification \{\
  [jsonrpc](#initializednotification-jsonrpc): "2.0";\
  [method](#initializednotification-method): "notifications/initialized";\
  [params](#initializednotification-params)?: [NotificationParams](#notificationparams);\
}This notification is sent from the client to the server after initialization has finished. <details><summary>Example: Initialized notification[Permalink](#initializednotification-example-initialized-notification)</summary><pre id="initializednotification-example-initialized-notification">`{  "jsonrpc": "2.0",  "method": "notifications/initialized"} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#initializednotification-jsonrpc)Inherited from [JSONRPCNotification](#jsonrpcnotification).[jsonrpc](#jsonrpcnotification-jsonrpc)method: "notifications/initialized"[Permalink](#initializednotification-method)Overrides [JSONRPCNotification](#jsonrpcnotification).[method](#jsonrpcnotification-method)params?: NotificationParams[Permalink](#initializednotification-params)Overrides [JSONRPCNotification](#jsonrpcnotification).[params](#jsonrpcnotification-params)

## `notifications/tasks/status`

### `TaskStatusNotification`

interface TaskStatusNotification \{\
  [jsonrpc](#taskstatusnotification-jsonrpc): "2.0";\
  [method](#taskstatusnotification-method): "notifications/tasks/status";\
  [params](#taskstatusnotification-params): [TaskStatusNotificationParams](#taskstatusnotificationparams);\
}An optional notification from the receiver to the requestor, informing them that a task's status has changed. Receivers are not required to send these notifications. jsonrpc: "2.0"[Permalink](#taskstatusnotification-jsonrpc)Inherited from [JSONRPCNotification](#jsonrpcnotification).[jsonrpc](#jsonrpcnotification-jsonrpc)method: "notifications/tasks/status"[Permalink](#taskstatusnotification-method)Overrides [JSONRPCNotification](#jsonrpcnotification).[method](#jsonrpcnotification-method)params: TaskStatusNotificationParams[Permalink](#taskstatusnotification-params)Overrides [JSONRPCNotification](#jsonrpcnotification).[params](#jsonrpcnotification-params)

### `TaskStatusNotificationParams`

TaskStatusNotificationParams: [NotificationParams](#notificationparams) & [Task](#task)Parameters for a `notifications/tasks/status` notification.&#x20;

## `notifications/message`

### `LoggingMessageNotification`

interface LoggingMessageNotification \{\
  [jsonrpc](#loggingmessagenotification-jsonrpc): "2.0";\
  [method](#loggingmessagenotification-method): "notifications/message";\
  [params](#loggingmessagenotification-params): [LoggingMessageNotificationParams](#loggingmessagenotificationparams);\
}JSONRPCNotification of a log message passed from server to client. If no `logging/setLevel` request has been sent from the client, the server MAY decide which messages to send automatically. <details><summary>Example: Log database connection failed[Permalink](#loggingmessagenotification-example-log-database-connection-failed)</summary><pre id="loggingmessagenotification-example-log-database-connection-failed">`{  "jsonrpc": "2.0",  "method": "notifications/message",  "params": {    "level": "error",    "logger": "database",    "data": {      "error": "Connection failed",      "details": {        "host": "localhost",        "port": 5432      }    }  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#loggingmessagenotification-jsonrpc)Inherited from [JSONRPCNotification](#jsonrpcnotification).[jsonrpc](#jsonrpcnotification-jsonrpc)method: "notifications/message"[Permalink](#loggingmessagenotification-method)Overrides [JSONRPCNotification](#jsonrpcnotification).[method](#jsonrpcnotification-method)params: LoggingMessageNotificationParams[Permalink](#loggingmessagenotification-params)Overrides [JSONRPCNotification](#jsonrpcnotification).[params](#jsonrpcnotification-params)

### `LoggingMessageNotificationParams`

interface LoggingMessageNotificationParams \{\
  [\_meta](#loggingmessagenotificationparams-_meta)?: [MetaObject](#metaobject);\
  [level](#loggingmessagenotificationparams-level): [LoggingLevel](#logginglevel);\
  [logger](#loggingmessagenotificationparams-logger)?: string;\
  [data](#loggingmessagenotificationparams-data): unknown;\
}Parameters for a `notifications/message` notification. <details><summary>Example: Log database connection failed[Permalink](#loggingmessagenotificationparams-example-log-database-connection-failed)</summary><pre id="loggingmessagenotificationparams-example-log-database-connection-failed">`{  "level": "error",  "logger": "database",  "data": {    "error": "Connection failed",    "details": {      "host": "localhost",      "port": 5432    }  }} `Copy</pre> </details>\_meta?: MetaObject[Permalink](#loggingmessagenotificationparams-_meta)Inherited from [NotificationParams](#notificationparams).[\_meta](#notificationparams-_meta)level: LoggingLevel[Permalink](#loggingmessagenotificationparams-level)The severity of this log message. logger?: string[Permalink](#loggingmessagenotificationparams-logger)An optional name of the logger issuing this message. data: unknown[Permalink](#loggingmessagenotificationparams-data)The data to be logged, such as a string message or an object. Any JSON serializable type is allowed here.&#x20;

## `notifications/progress`

### `ProgressNotification`

interface ProgressNotification \{\
  [jsonrpc](#progressnotification-jsonrpc): "2.0";\
  [method](#progressnotification-method): "notifications/progress";\
  [params](#progressnotification-params): [ProgressNotificationParams](#progressnotificationparams);\
}An out-of-band notification used to inform the receiver of a progress update for a long-running request. <details><summary>Example: Progress message[Permalink](#progressnotification-example-progress-message)</summary><pre id="progressnotification-example-progress-message">`{  "jsonrpc": "2.0",  "method": "notifications/progress",  "params": {    "progressToken": "oivaizmir",    "progress": 50,    "total": 100,    "message": "Reticulating splines..."  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#progressnotification-jsonrpc)Inherited from [JSONRPCNotification](#jsonrpcnotification).[jsonrpc](#jsonrpcnotification-jsonrpc)method: "notifications/progress"[Permalink](#progressnotification-method)Overrides [JSONRPCNotification](#jsonrpcnotification).[method](#jsonrpcnotification-method)params: ProgressNotificationParams[Permalink](#progressnotification-params)Overrides [JSONRPCNotification](#jsonrpcnotification).[params](#jsonrpcnotification-params)

### `ProgressNotificationParams`

interface ProgressNotificationParams \{\
  [\_meta](#progressnotificationparams-_meta)?: [MetaObject](#metaobject);\
  [progressToken](#progressnotificationparams-progresstoken): [ProgressToken](#progresstoken);\
  [progress](#progressnotificationparams-progress): number;\
  [total](#progressnotificationparams-total)?: number;\
  [message](#progressnotificationparams-message)?: string;\
}Parameters for a [notifications/progress](#progressnotification) notification. <details><summary>Example: Progress message[Permalink](#progressnotificationparams-example-progress-message)</summary><pre id="progressnotificationparams-example-progress-message">`{  "progressToken": "oivaizmir",  "progress": 50,  "total": 100,  "message": "Reticulating splines..."} `Copy</pre> </details>\_meta?: MetaObject[Permalink](#progressnotificationparams-_meta)Inherited from [NotificationParams](#notificationparams).[\_meta](#notificationparams-_meta)progressToken: ProgressToken[Permalink](#progressnotificationparams-progresstoken)The progress token which was given in the initial request, used to associate this notification with the request that is proceeding. progress: number[Permalink](#progressnotificationparams-progress)The progress thus far. This should increase every time progress is made, even if the total is unknown. total?: number[Permalink](#progressnotificationparams-total)Total number of items to process (or total progress required), if known. message?: string[Permalink](#progressnotificationparams-message)An optional message describing the current progress.&#x20;

## `notifications/prompts/list_changed`

### `PromptListChangedNotification`

interface PromptListChangedNotification \{\
  [jsonrpc](#promptlistchangednotification-jsonrpc): "2.0";\
  [method](#promptlistchangednotification-method): "notifications/prompts/list\_changed";\
  [params](#promptlistchangednotification-params)?: [NotificationParams](#notificationparams);\
}An optional notification from the server to the client, informing it that the list of prompts it offers has changed. This may be issued by servers without any previous subscription from the client. <details><summary>Example: Prompts list changed[Permalink](#promptlistchangednotification-example-prompts-list-changed)</summary><pre id="promptlistchangednotification-example-prompts-list-changed">`{  "jsonrpc": "2.0",  "method": "notifications/prompts/list_changed"} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#promptlistchangednotification-jsonrpc)Inherited from [JSONRPCNotification](#jsonrpcnotification).[jsonrpc](#jsonrpcnotification-jsonrpc)method: "notifications/prompts/list\_changed"[Permalink](#promptlistchangednotification-method)Overrides [JSONRPCNotification](#jsonrpcnotification).[method](#jsonrpcnotification-method)params?: NotificationParams[Permalink](#promptlistchangednotification-params)Overrides [JSONRPCNotification](#jsonrpcnotification).[params](#jsonrpcnotification-params)

## `notifications/resources/list_changed`

### `ResourceListChangedNotification`

interface ResourceListChangedNotification \{\
  [jsonrpc](#resourcelistchangednotification-jsonrpc): "2.0";\
  [method](#resourcelistchangednotification-method): "notifications/resources/list\_changed";\
  [params](#resourcelistchangednotification-params)?: [NotificationParams](#notificationparams);\
}An optional notification from the server to the client, informing it that the list of resources it can read from has changed. This may be issued by servers without any previous subscription from the client. <details><summary>Example: Resources list changed[Permalink](#resourcelistchangednotification-example-resources-list-changed)</summary><pre id="resourcelistchangednotification-example-resources-list-changed">`{  "jsonrpc": "2.0",  "method": "notifications/resources/list_changed"} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#resourcelistchangednotification-jsonrpc)Inherited from [JSONRPCNotification](#jsonrpcnotification).[jsonrpc](#jsonrpcnotification-jsonrpc)method: "notifications/resources/list\_changed"[Permalink](#resourcelistchangednotification-method)Overrides [JSONRPCNotification](#jsonrpcnotification).[method](#jsonrpcnotification-method)params?: NotificationParams[Permalink](#resourcelistchangednotification-params)Overrides [JSONRPCNotification](#jsonrpcnotification).[params](#jsonrpcnotification-params)

## `notifications/resources/updated`

### `ResourceUpdatedNotification`

interface ResourceUpdatedNotification \{\
  [jsonrpc](#resourceupdatednotification-jsonrpc): "2.0";\
  [method](#resourceupdatednotification-method): "notifications/resources/updated";\
  [params](#resourceupdatednotification-params): [ResourceUpdatedNotificationParams](#resourceupdatednotificationparams);\
}A notification from the server to the client, informing it that a resource has changed and may need to be read again. This should only be sent if the client previously sent a [resources/subscribe](#subscriberequest) request. <details><summary>Example: File resource updated notification[Permalink](#resourceupdatednotification-example-file-resource-updated-notification)</summary><pre id="resourceupdatednotification-example-file-resource-updated-notification">`{  "jsonrpc": "2.0",  "method": "notifications/resources/updated",  "params": {    "uri": "file:///project/src/main.rs"  }} `Copy</pre> </details>jsonrpc: "2.0"[Permalink](#resourceupdatednotification-jsonrpc)Inherited from [JSONRPCNotification](#jsonrpcnotification).[jsonrpc](#jsonrpcnotification-jsonrpc)method: "notifications/resources/updated"[Permalink](#resourceupdatednotification-method)Overrides [JSONRPCNotification](#jsonrpcnotification).[method](#jsonrpcnotification-method)params: ResourceUpdatedNotificationParams[Permalink](#resourceupdatednotification-params)Overrides [JSONRPCNotification](#jsonrpcnotification).[params](#jsonrpcnotification-params)

### `ResourceUpdatedNotificationParams`

interface ResourceUpdatedNotificationParams \{\
  [\_meta](#resourceupdatednotificationparams-_meta)?: [MetaObject](#metaobject);\
  [uri](#resourceupdatednotificationparams-uri): string;\
[...]
